#include <stdlib.h>
#include <fstream>
#include <iostream>
#include <math.h>
#include <GL/glut.h>

using namespace std;

/* coordinate axis */
#define COR_X 0
#define COR_Y 1
#define COR_Z 2


/* factor with which the object is scaled in the viewer */
float SCALE_FACTOR = (float) 0.008;


GLfloat light_diffuse[] = {1.0, 1.0, 1.0, 1.0};
GLfloat light_position[] = {0.0, -2.0, 3.0, 0.0};
GLUquadricObj *qobj;

struct Triangle
{
  int node_index_A;
  int node_index_B;
  int node_index_C;
  
  GLfloat face_normal[3];
};


/**********************************************************************/
/* hsv2rgb:                                                           */
/**********************************************************************/
/* <-- rgb coordinates of hsv color, rgb in [0,1]^3                   */
/* --> hsv color coordinates h in [0, 360), s in [0,1], v in [0,1]    */
/**********************************************************************/
/* Converts hsv to rgb                                                */
/**********************************************************************/

void hsv2rgb(float h, float s, float v, float *r, float *g, float *b)
{
  



  /* part 2 of the exercise */	
  /* fill in here your code */




}
 
 
/************************************************************************/
/* setVertexNormal:                                                     */
/************************************************************************/                  
/* --> node_index: index of the node, for which we calculate the normal */
/*     triangle_array: list of triangle faces                           */
/*     nbr_of_triangles: number of triangle faces in triangle_array     */
/************************************************************************/
/* Calculates and defines the surface normal for the given node by      */
/* combining the face normals of all adjacent triangles.                */                                            
/************************************************************************/
 
void setVertexNormal(int node_index, Triangle *triangle_array, int nbr_of_triangles)
{




   /* part 1c of the exercise */
   /* fill in your code here  */

 


}


/************************************************************************/
/* setVertexColor:                                                      */
/************************************************************************/                  
/* --> coordinate: the 3D coordinates of the node                       */
/************************************************************************/
/* Defines, respectively calculates the color for the given node in     */
/* dependance of its 3D coordinates                                     */                                            
/************************************************************************/
  
void setVertexColor(float *coordinate)
{
 
  float interesting_point[2]; /* coordinates of a point of interest */
 
  /* set the coordinates of the point of interest */
  interesting_point[COR_X] = 250;
  interesting_point[COR_Y] = 280;
 


   
   /* part 3 of the exercise */
   /* fill in here your code */




}
 
 
/************************************************************************/
/* loadObject:                                                          */
/************************************************************************/                  
/* --> object_file_name: filename of the file containing of a list of   */
/*                       nodes and list of triangles                    */
/************************************************************************/
/* Loads an surface mesh from the given file and generates the          */
/* corresponding display list.                                          */                                            
/************************************************************************/
  
void loadObject(char *object_file_name)
{
  ifstream input_file; /* input file stream */
  int data_format;     /* format of the data (not used in this program) */
  int nbr_of_nodes;    /* number of nodes defined in the file */
  int nbr_of_triangles; /* number of triangles defined in the file */
  
  int node_index;      /* index into the node array */
  int triangle_index;  /* number of the current triangle  */

  
/*------------------------------------------------------------------*/
/* open the mesh file                                               */
/*------------------------------------------------------------------*/
 
  cout << "Mesh file: " << object_file_name;
 
  input_file.open(object_file_name);
 
  /* check if the file is correct opened */
  if(!input_file) 
  {
	cerr << " opening failed!" << endl;
	return;
  }
  else
  {
	cout << " opened..." << endl;
  }
  
  
/*------------------------------------------------------------------ */
/* read the data info                                                */
/*------------------------------------------------------------------ */
  
  /* the first number gives us the data-format of the file */
  /* (we don't use this number here) */
  input_file >> data_format;
  
  /* get the number of nodes */
  input_file >> nbr_of_nodes;

  /* get the number of tetrahedra */
  input_file >> nbr_of_triangles;


/*------------------------------------------------------------------ */
/* read the nodes and store them in an array                         */
/*------------------------------------------------------------------ */
  
  /* create node array of size nbr_of_nodes */
  float (* const node_array)[3] = new float [nbr_of_nodes][3];
  
  /* read the nodes listed in the input file */
  for(node_index = 0; node_index < nbr_of_nodes; node_index++)
  {  
	/* read one node position from the input file */
	input_file >> node_array[node_index][COR_X]; 
	input_file >> node_array[node_index][COR_Y]; 
	input_file >> node_array[node_index][COR_Z];
  }
  
  
/*------------------------------------------------------------------ */
/* read the triangles and store them in struct array                 */
/*------------------------------------------------------------------ */
  
  Triangle *triangle_array = new Triangle [nbr_of_triangles];


  for(triangle_index = 0; triangle_index < nbr_of_triangles; triangle_index++)
  {
	/* read the node indices of the triangle from the input file  */
	input_file >> triangle_array[triangle_index].node_index_A; 
	input_file >> triangle_array[triangle_index].node_index_B; 
	input_file >> triangle_array[triangle_index].node_index_C;
  }
  
  
/*------------------------------------------------------------------ */
/* close the input file                                              */
/*------------------------------------------------------------------ */
  
  input_file.close();

  
/*------------------------------------------------------------------ */
/* calculate the face normals                                        */
/*------------------------------------------------------------------ */

 


   /* part 1b of the exercise */
   /* fill in your code here  */

 
	
	
/*------------------------------------------------------------------ */
/* construct the display list                                        */
/*------------------------------------------------------------------ */

  /* default normal for all faces */ 
  glNormal3f(0.0, 1.0, 0.0);





   /* part 1a of the exercise */
   /* fill in your code here  */

  


}


void initGraphics(void)
{
  /* enable a light source */
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);
  
  /* enable automatic normalization of the surface normals */
  glEnable(GL_NORMALIZE);
  
  /* specify the shade model (flat (GL_FLAT) or smooth shading (GL_SMOOTH)*/
  glShadeModel(GL_SMOOTH);

  /* set the projection parameters */
  glMatrixMode(GL_PROJECTION);
  gluPerspective( /* Field of view in degree */ 40.0, 
    /* Aspect ratio */ 1.0,
    /* Z near */ 1.0, /* Z far */ 10.0);
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(0.0, -1.5, 3.0,  /* Eye is at (0,0,3) */
    0.0, 0.0, 0.0,      /* Center is at (0,0,0) */
    0.0, 1.0, 0.0);      /* Up is in positive Y direction. */
  glTranslatef(0.0, 0.0, -1.0);
}


void display(void)
{
  // clear the window
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  // translate the whole scene
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glTranslatef((float)-1.3, (float)-1.5, (float)0.0);
  
  /* scales the scene to an appropriate size */
  glScalef(SCALE_FACTOR, SCALE_FACTOR, 1.3*SCALE_FACTOR);


  /* part 1a of the exercise */
  /* fill in your code here */      
  
  /* Render the display list. */




  glPopMatrix();
  
  /* bring the background buffer to the front */
  glutSwapBuffers();
}


void reshape(int w, int h)
{
  /* scale the image to the size of the window */
  glViewport(0, 0, w, h);
}



void main(int argc, char **argv)
{
  /* initialize the glut environment */
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  
  /* create a new window */
  glutCreateWindow("Colors");
  
  /* set the size of the window */
  glutReshapeWindow(800, 600);
  
  /* register the display callback function */
  glutDisplayFunc(display);
  
  /* register the reshape callback function */
  glutReshapeFunc(reshape);
  
  /* check if a argument is given*/
  if(argc == 2)
  {
	/* load the object with the name given as argument */
	loadObject(argv[1]);
  }
  else
  { 
	/* load the default object */
	loadObject("vulcano_mesh2.raw");  
  }
  
  /* initialize the OpenGL rendering */
  initGraphics();
  
  /* hand over the control to glut server loop */
  glutMainLoop();
}

